/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.maptomultivaluemapexample2;

import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import java.util.Arrays;
import java.util.Map;
import java.util.stream.Collectors;

/**
 *
 * @author omozegieaziegbe
 */
public class MapToMultiValueMapExample2 {

    public static MultiValueMap<String, String> convertUsingStreams(Map<String, String[]> map) {
        return map.entrySet().stream()
                .collect(Collectors.toMap(
                        Map.Entry::getKey,
                        entry -> Arrays.asList(entry.getValue()),
                        (oldValue, newValue) -> {
                            oldValue.addAll(newValue);
                            return oldValue;
                        },
                        LinkedMultiValueMap::new
                ));
    }

    public static void main(String[] args) {
        Map<String, String[]> carPreferences = Map.of(
                "Toyota", new String[]{"Camry", "Corolla", "Prius"},
                "Ford", new String[]{"Mustang", "Fiesta", "Focus"},
                "BMW", new String[]{"X5", "X3", "i8"}
        );

        MultiValueMap<String, String> multiValueMap = convertUsingStreams(carPreferences);

        System.out.println(multiValueMap);
    }
}
